# data_partition works as expected

    Code
      data_partition(letters, seed = 123)
    Output
      $training
        X.o. X.s. X.n. X.c. X.j. X.r. X.k. X.e. X.x. X.y. X.w. X.t. X.i. X.l. X.u.
      1    o    s    n    c    j    r    k    e    x    y    w    t    i    l    u
        X.m. X.p. X.h.
      1    m    p    h
      
      $test
        X.a. X.b. X.d. X.f. X.g. X.q. X.v. X.z.
      1    a    b    d    f    g    q    v    z
      

---

    Code
      str(data_partition(df))
    Output
      List of 2
       $ training:'data.frame':	105 obs. of  6 variables:
        ..$ Sepal.Length: num [1:105] 4.3 5 7.7 4.4 5.9 6.5 5.5 5.5 5.8 6.1 ...
        ..$ Sepal.Width : num [1:105] 3 3.3 3.8 3.2 3 3 2.5 2.6 2.7 3 ...
        ..$ Petal.Length: num [1:105] 1.1 1.4 6.7 1.3 5.1 5.2 4 4.4 5.1 4.6 ...
        ..$ Petal.Width : num [1:105] 0.1 0.2 2.2 0.2 1.8 2 1.3 1.2 1.9 1.4 ...
        ..$ Species     : Factor w/ 3 levels "setosa","versicolor",..: 1 1 3 1 3 3 2 2 3 2 ...
        ..$ Smell       : chr [1:105] "Light" "Light" "Light" "Strong" ...
       $ test    :'data.frame':	45 obs. of  6 variables:
        ..$ Sepal.Length: num [1:45] 5.1 4.9 4.7 5 5.4 5.1 5.7 5.2 5.2 5.2 ...
        ..$ Sepal.Width : num [1:45] 3.5 3 3.2 3.6 3.7 3.5 3.8 3.5 3.4 4.1 ...
        ..$ Petal.Length: num [1:45] 1.4 1.4 1.3 1.4 1.5 1.4 1.7 1.5 1.4 1.5 ...
        ..$ Petal.Width : num [1:45] 0.2 0.2 0.2 0.2 0.2 0.3 0.3 0.2 0.2 0.1 ...
        ..$ Species     : Factor w/ 3 levels "setosa","versicolor",..: 1 1 1 1 1 1 1 1 1 1 ...
        ..$ Smell       : chr [1:45] "Strong" "Light" "Strong" "Strong" ...

---

    Code
      str(data_partition(df, group = "Species"))
    Output
      List of 2
       $ training:'data.frame':	105 obs. of  6 variables:
        ..$ Sepal.Length: num [1:105] 4.8 5.8 4.3 4.7 4.5 4.4 5.5 4.6 4.8 5 ...
        ..$ Sepal.Width : num [1:105] 3.1 4 3 3.2 2.3 3.2 3.5 3.2 3.4 3 ...
        ..$ Petal.Length: num [1:105] 1.6 1.2 1.1 1.3 1.3 1.3 1.3 1.4 1.9 1.6 ...
        ..$ Petal.Width : num [1:105] 0.2 0.2 0.1 0.2 0.3 0.2 0.2 0.2 0.2 0.2 ...
        ..$ Species     : Factor w/ 3 levels "setosa","versicolor",..: 1 1 1 1 1 1 1 1 1 1 ...
        ..$ Smell       : chr [1:105] "Strong" "Strong" "Light" "Strong" ...
       $ test    :'data.frame':	45 obs. of  6 variables:
        ..$ Sepal.Length: num [1:45] 5.1 4.9 5.4 5.7 5.1 5.1 5.1 4.6 5.5 4.9 ...
        ..$ Sepal.Width : num [1:45] 3.5 3 3.9 4.4 3.5 3.8 3.7 3.6 4.2 3.1 ...
        ..$ Petal.Length: num [1:45] 1.4 1.4 1.7 1.5 1.4 1.5 1.5 1 1.4 1.5 ...
        ..$ Petal.Width : num [1:45] 0.2 0.2 0.4 0.4 0.3 0.3 0.4 0.2 0.2 0.2 ...
        ..$ Species     : Factor w/ 3 levels "setosa","versicolor",..: 1 1 1 1 1 1 1 1 1 1 ...
        ..$ Smell       : chr [1:45] "Strong" "Light" "Light" "Light" ...

---

    Code
      str(data_partition(df, group = c("Species", "Smell")))
    Output
      List of 2
       $ training:'data.frame':	102 obs. of  6 variables:
        ..$ Sepal.Length: num [1:102] 4.7 4.9 5.2 5.4 5.1 5 5.1 4.9 4.8 4.8 ...
        ..$ Sepal.Width : num [1:102] 3.2 3.6 3.5 3.9 3.8 3.2 3.7 3.1 3 3.4 ...
        ..$ Petal.Length: num [1:102] 1.6 1.4 1.5 1.7 1.5 1.2 1.5 1.5 1.4 1.6 ...
        ..$ Petal.Width : num [1:102] 0.2 0.1 0.2 0.4 0.3 0.2 0.4 0.1 0.3 0.2 ...
        ..$ Species     : Factor w/ 3 levels "setosa","versicolor",..: 1 1 1 1 1 1 1 1 1 1 ...
        ..$ Smell       : chr [1:102] "Light" "Light" "Light" "Light" ...
       $ test    :'data.frame':	48 obs. of  6 variables:
        ..$ Sepal.Length: num [1:48] 4.9 4.6 5 4.3 5.7 5.1 5 5.4 5.5 5.9 ...
        ..$ Sepal.Width : num [1:48] 3 3.1 3.4 3 4.4 3.3 3 3.4 2.3 3 ...
        ..$ Petal.Length: num [1:48] 1.4 1.5 1.5 1.1 1.5 1.7 1.6 1.5 4 4.2 ...
        ..$ Petal.Width : num [1:48] 0.2 0.2 0.2 0.1 0.4 0.5 0.2 0.4 1.3 1.5 ...
        ..$ Species     : Factor w/ 3 levels "setosa","versicolor",..: 1 1 1 1 1 1 1 1 2 2 ...
        ..$ Smell       : chr [1:48] "Light" "Light" "Light" "Light" ...

